gi-gtk4-4.0.12: Gtk 4.x bindings

Copyright | Will Thompson and Iñaki García Etxebarria
License | LGPL-2.1
Maintainer | Iñaki García Etxebarria
Safe Haskell | None
Language | Haskell2010

GI.Gtk.Objects.Tooltip

Contents

- Exported types
- Methods
  - setCustom
  - setIcon
  - setIconFromGicon
  - setIconFromIconName
  - setMarkup
  - setText
  - setTipArea

Description

Represents a widget tooltip.

Basic tooltips can be realized simply by using `widgetSetTooltipText` or `widgetSetTooltipMarkup` without any explicit tooltip object.

When you need a tooltip with a little more fancy contents, like adding an image, or you want the tooltip to have different contents per `GtkTreeView` row or cell, you will have to do a little more work:

- Set the Widget:hasTooltip property to `True`. This will make GTK monitor the widget for motion and related events which are needed to determine when and where to show a tooltip.
- Connect to the Widget::queryTooltip signal. This signal will be emitted when a tooltip is supposed to be shown. One of the arguments passed to the signal handler is a `GtkTooltip` object. This is the object that we are about to display as a tooltip, and can be manipulated in your callback using functions like `tooltipSetIcon`. There are functions for setting the tooltip’s markup, setting an image from a named icon, or even putting in a custom widget.
- Return `True` from your queryTooltip handler. This causes the tooltip to be show. If you return `False`, it will not be shown.

Synopsis

- newtype Tooltip = Tooltip (ManagedPtr Tooltip)
- class (GObject o, IsDescendantOf Tooltip o) => IsTooltip o
- toTooltip :: (MonadIO m, IsTooltip o) => o -> m Tooltip
- tooltipSetCustom :: (HasCallStack, MonadIO m, IsTooltip a, IsWidget b) => a -> Maybe b -> m ()
- tooltipSetIcon :: (HasCallStack, MonadIO m, IsTooltip a, IsPaintable b) => a -> Maybe b -> m ()
- tooltipSetIconFromGicon :: (HasCallStack, MonadIO m, IsTooltip a, IsIcon b) => a -> Maybe b -> m ()
- tooltipSetIconFromIconName :: (HasCallStack, MonadIO m, IsTooltip a) => a -> Maybe Text -> m ()
- tooltipSetMarkup :: (HasCallStack, MonadIO m, IsTooltip a) => a -> Maybe Text -> m ()
- tooltipSetText :: (HasCallStack, MonadIO m, IsTooltip a) => a -> Maybe Text -> m ()
- tooltipSetTipArea :: (HasCallStack, MonadIO m, IsTooltip a) => a -> Rectangle -> m ()

# Exported types

newtype Tooltip Source #

Memory-managed wrapper type.

Constructors

Tooltip (ManagedPtr Tooltip) |

#### Instances

Instances details

Eq Tooltip Source # |
Instance details Defined in GI.Gtk.Objects.Tooltip Methods (==) :: Tooltip -> Tooltip -> Bool Source # (/=) :: Tooltip -> Tooltip -> Bool Source #
GObject Tooltip Source # |
Instance details Defined in GI.Gtk.Objects.Tooltip
ManagedPtrNewtype Tooltip Source # |
Instance details Defined in GI.Gtk.Objects.Tooltip Methods toManagedPtr :: Tooltip -> ManagedPtr Tooltip Source #
TypedObject Tooltip Source # |
Instance details Defined in GI.Gtk.Objects.Tooltip Methods glibType :: IO GType Source #
HasParentTypes Tooltip Source # |
Instance details Defined in GI.Gtk.Objects.Tooltip
IsGValue (Maybe Tooltip) Source # | Convert `Tooltip` to and from `GValue`. See `toGValue` and `fromGValue`.
Instance details Defined in GI.Gtk.Objects.Tooltip Methods gvalueGType_ :: IO GType Source # gvalueSet_ :: Ptr GValue -> Maybe Tooltip -> IO () Source # gvalueGet_ :: Ptr GValue -> IO (Maybe Tooltip) Source #
type ParentTypes Tooltip Source # |
Instance details Defined in GI.Gtk.Objects.Tooltip type ParentTypes Tooltip = '[Object]

class (GObject o, IsDescendantOf Tooltip o) => IsTooltip o Source #

Type class for types which can be safely cast to `Tooltip`, for instance with `toTooltip`.

#### Instances

Instances details

(GObject o, IsDescendantOf Tooltip o) => IsTooltip o Source # |
Instance details Defined in GI.Gtk.Objects.Tooltip

toTooltip :: (MonadIO m, IsTooltip o) => o -> m Tooltip Source #

Cast to `Tooltip`, for types for which this is known to be safe. For general casts, use `castTo`.

# Methods

### Click to display all available methods, including inherited ones

Expand

#### Methods

bindProperty, bindPropertyFull, forceFloating, freezeNotify, getv, isFloating, notify, notifyByPspec, ref, refSink, runDispose, stealData, stealQdata, thawNotify, unref, watchClosure.

#### Getters

getData, getProperty, getQdata.

#### Setters

setCustom, setData, setDataFull, setIcon, setIconFromGicon, setIconFromIconName, setMarkup, setProperty, setText, setTipArea.

## setCustom

tooltipSetCustom Source #

Arguments

:: (HasCallStack, MonadIO m, IsTooltip a, IsWidget b) |
=> a | `tooltip`: a `GtkTooltip`
-> Maybe b | `customWidget`: a `GtkWidget`, or `Nothing` to unset the old custom widget.
-> m () |

Replaces the widget packed into the tooltip with `customWidget`. `customWidget` does not get destroyed when the tooltip goes away. By default a box with a `GtkImage` and `GtkLabel` is embedded in the tooltip, which can be configured using `tooltipSetMarkup` and `tooltipSetIcon`.

## setIcon

tooltipSetIcon Source #

Arguments

:: (HasCallStack, MonadIO m, IsTooltip a, IsPaintable b) |
=> a | `tooltip`: a `GtkTooltip`
-> Maybe b | `paintable`: a `GdkPaintable`
-> m () |

Sets the icon of the tooltip (which is in front of the text) to be `paintable`. If `paintable` is `Nothing`, the image will be hidden.

## setIconFromGicon

tooltipSetIconFromGicon Source #

Arguments

:: (HasCallStack, MonadIO m, IsTooltip a, IsIcon b) |
=> a | `tooltip`: a `GtkTooltip`
-> Maybe b | `gicon`: a `GIcon` representing the icon
-> m () |

Sets the icon of the tooltip (which is in front of the text) to be the icon indicated by `gicon` with the size indicated by `size`. If `gicon` is `Nothing`, the image will be hidden.

## setIconFromIconName

tooltipSetIconFromIconName Source #

Arguments

:: (HasCallStack, MonadIO m, IsTooltip a) |
=> a | `tooltip`: a `GtkTooltip`
-> Maybe Text | `iconName`: an icon name
-> m () |

Sets the icon of the tooltip (which is in front of the text) to be the icon indicated by `iconName` with the size indicated by `size`. If `iconName` is `Nothing`, the image will be hidden.

## setMarkup

tooltipSetMarkup Source #

Arguments

:: (HasCallStack, MonadIO m, IsTooltip a) |
=> a | `tooltip`: a `GtkTooltip`
-> Maybe Text | `markup`: a string with Pango markup or `NLL`
-> m () |

Sets the text of the tooltip to be `markup`.

The string must be marked up with Pango markup. If `markup` is `Nothing`, the label will be hidden.

## setText

tooltipSetText Source #

Arguments

:: (HasCallStack, MonadIO m, IsTooltip a) |
=> a | `tooltip`: a `GtkTooltip`
-> Maybe Text | `text`: a text string
-> m () |

Sets the text of the tooltip to be `text`.

If `text` is `Nothing`, the label will be hidden. See also `tooltipSetMarkup`.

## setTipArea

tooltipSetTipArea Source #

Arguments

:: (HasCallStack, MonadIO m, IsTooltip a) |
=> a | `tooltip`: a `GtkTooltip`
-> Rectangle | `rect`: a `GdkRectangle`
-> m () |

Sets the area of the widget, where the contents of this tooltip apply, to be `rect` (in widget coordinates). This is especially useful for properly setting tooltips on `GtkTreeView` rows and cells, `GtkIconViews`, etc.

For setting tooltips on `GtkTreeView`, please refer to the convenience functions for this: `treeViewSetTooltipRow` and `treeViewSetTooltipCell`.